<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action("init", "dispatch_checkboxes_to_wp_form_func", 9);
function dispatch_checkboxes_to_wp_form_func()
{
	global $fm_settings;

	if (isset($fm_settings['fm_sign_up_checkboxes'])) {

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['comment_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['comment_form'] == "on") {
				add_action('thesis_hook_after_comment_box', 'fm_comment_form_default_fields', 11);
				add_action('comment_form', 'fm_comment_form_default_fields', 11);
				add_action('comment_post', 'fm_comment_form_default_fields_save_meta_data', 40, 2);
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['reg_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['reg_form'] == "on") {
				add_action('register_form', 'fm_register_form_default_fields', 20);
				add_action('user_register', 'fm_register_form_default_fields_save_meta_data', 90, 1);
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['woo_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['woo_form'] == "on") {
				add_action('woocommerce_checkout_billing', 'fm_woo_form_default_fields', 11);
				add_action('woocommerce_checkout_process', 'fm_woo_form_default_fields_save_meta_data');
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['easy_dig_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['easy_dig_form'] == "on") {
				add_action('edd_checkout_form_bottom', 'fm_easy_dig_form_default_fields', 11);
				add_action('edd_purchase', 'fm_easy_dig_form_default_fields_save_meta_data', 9);
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['bbpress_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['bbpress_form'] == "on") {
				add_action('bbp_theme_after_topic_form_subscriptions', 'fm_bbpress_form_default_fields', 10);
				add_action('bbp_theme_after_reply_form_subscription', 'fm_bbpress_form_default_fields', 10);
				add_action('bbp_theme_anonymous_form_extras_bottom', 'fm_bbpress_form_default_fields', 10);
				add_action('bbp_new_topic', array($this, 'fm_bbpress_form_default_fields_save_meta_data_new_topic'), 10, 4);
				add_action('bbp_new_reply', array($this, 'fm_bbpress_form_default_fields_save_meta_data_new_reply'), 10, 5);
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form'] == "on") {
				add_action('signup_extra_fields', 'fm_multisite_form_default_fields', 20);

				add_action('signup_blogform', 'fm_multisite_form_default_fields_save_meta_data_hidden_checkbox', 20);
				add_action('wpmu_activate_blog', 'fm_multisite_form_default_fields_on_multisite_blog_signup', 20, 5);
				add_action('wpmu_activate_user', 'fm_multisite_form_default_fields_on_multisite_user_signup', 20, 3);

				add_filter('add_signup_meta', 'fm_multisite_form_default_fields_save_meta_data_meta');
			}
		}

		if (isset($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['buddypress_form'])) {
			if ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['buddypress_form'] == "on") {
				add_action('bp_before_registration_submit_buttons', 'fm_buddypress_form_default_fields', 20);
				add_action('bp_core_signup_user', 'fm_buddypress_form_default_fields_save_meta_data', 10, 4);
			}
		}
	}
}