<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('wp_footer', 'fm_add_popup_to_footer', 100);
add_action('wp_head', 'fm_add_popup_to_header', 100);

function fm_add_popup_to_header()
{
	global $wpdb;
	$results = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'fm_forms', OBJECT);

	echo '<!-- FRESHMAIL POPUPS JAVASCRIPT DO NOT MODIFY -->';
	foreach ($results as $key => $val) {
		$form_var = unserialize($val->freshmail_form_var);
		$postType = get_post_type(get_the_ID());
		if (($postType == 'page')) {
			if (!isset($form_var['allowed_pages']) || !in_array(get_the_ID(), $form_var['allowed_pages'])) {
				break;
			}
		} elseif ($postType == 'post') {
			if (!isset($form_var['allowed_main_posts']) || !in_array(get_the_ID(), $form_var['allowed_main_posts'])) {
				break;
			}
		} elseif ($postType == 'product') {
			if (!isset($form_var['allowed_products']) || !in_array(get_the_ID(), $form_var['allowed_products'])) {
				break;
			}
		} else {
			break;
		}

		$allowedPages = array_merge((isset($form_var['allowed_pages']) ? $form_var['allowed_pages'] : array()), (isset($form_var['allowed_main_posts']) ? $form_var['allowed_main_posts'] : array()));
		$allowedPages = array_merge($allowedPages, (isset($form_var['allowed_products']) ? $form_var['allowed_products'] : array()));
		/* check if page/post is allowed to display pop-up */
		if (!in_array(get_the_ID(), $allowedPages)) {
			break;
		}

		if (isset($_SESSION['fm_form_popup'][$val->form_id]['count'])) {
			$_SESSION['fm_form_popup'][$val->form_id]['count'] += 1;;
		} else {
			$_SESSION['fm_form_popup'][$val->form_id]['count'] = 0;
		}

		$show_popup = true;
		$javascript_included = false;
		$shortcode_atts = ' in_popup="true"';
		if ($form_var['show_in_pop_up'] == "yes") {
			// Don't show pop-ups on mobile phones
			if (isset($form_var['pop_ups_mobile']) and wp_is_mobile()) {
				if ($form_var['pop_ups_mobile'] == "true") {
					$show_popup = false;
				}
			}
			// Don't show on specified UTM ta
			if (isset($form_var['dont_show_utm2'])) {
				if (isset($_GET[$form_var['dont_show_utm2']])) {
					if ($_GET[$form_var['dont_show_utm2']] == $form_var['dont_show_utm_value']) {
						$show_popup = false;
					}
				}
			}

			// The maximum number of pop-up displays per user
			if (isset($_SESSION['fm_form_popup'][$val->form_id]['count']) and $form_var['max_popups_number']) {
				if ($_SESSION['fm_form_popup'][$val->form_id]['count'] >= $form_var['max_popups_number']) {
					$show_popup = false;
				}
			}
			if (isset($_SESSION['fm_form_popup'][$val->form_id]['lasttime'])) {
				if ((time() - $_SESSION['fm_form_popup'][$val->form_id]['lasttime']) <= $form_var['lag_time']) {
					$show_popup = false;
				}
			}

			// Show a pop-up when a user leaves the website
			if (isset($form_var['show_leaves'])) {
				if ($show_popup and !$javascript_included) {
					$javascript_included = true; ?>
					<script type="text/javascript">
						jQuery(document).ready(function(){
							jQuery(document).bind("mousemove", function(event){
								if(event.pageY < 15){
									jQuery("#fm_popup_<?php echo $val->form_id; ?>").dialog({ modal: true, resizable: false, draggable: false, autoOpen: false, width: 'auto', dialogClass: 'freshmail_dialog' });
									jQuery("#fm_popup_<?php echo $val->form_id; ?>").parent().css({position: "fixed"}).end().dialog('open');
									jQuery.post(static_var.ajax, {'action': 'popup_show', 'form_id':<?php echo $val->form_id; ?>});
									jQuery(document).unbind("mousemove");
								}
							});
						});
					</script>
				<?php
				}
			}

			// check when
			if ($form_var['when_to_show'] != 'immediately' and !$javascript_included) {
				if ($form_var['when_to_show'] == "sec_min") {
					if ($form_var['sec_min'][1] == 'minutes') {
						$form_var['sec_min'][0] = $form_var['sec_min'][0] / 60;
					}
					$javascript_included = true; ?>
					<script type="text/javascript">
						jQuery(document).ready(function(){
							console.log('FreshMail - show pop-ups after <?php echo $form_var['sec_min'][0]; ?>seconds.');
							setTimeout(function(){
								console.log('FreshMail - form <?php echo $val->form_id; ?> opened.');
								jQuery("#fm_popup_<?php echo $val->form_id; ?>").dialog({ modal: true, resizable: false, draggable: false, autoOpen: false, width: 'auto', dialogClass: 'freshmail_dialog' });
								jQuery("#fm_popup_<?php echo $val->form_id; ?>").parent().css({position: "fixed"}).end().dialog('open');
								jQuery.post(static_var.ajax, {'action': 'popup_show', 'form_id':<?php echo $val->form_id; ?>});
							}, <?php echo $form_var['sec_min'][0]*1000; ?>);
						});
					</script>
				<?php
				}

				if ($form_var['when_to_show'] == "per_px") {
					$javascript_included = true; ?>
					<script type="text/javascript">
						window.showFreshmailPopup = true;
						jQuery(document).ready(function(){
							console.log('FreshMail - show pop-ups after <?php echo $form_var['per_px'][0].' '.$form_var['per_px'][1]; ?> scrolled.');
							jQuery(document).bind("scroll", function(event){
								var max = <?php
								if ($form_var['per_px'][1]=="percent") {
									echo "jQuery(document).height() * ".($form_var['per_px'][0]/100);
								} else {
									echo $form_var['per_px'][0];
								}	?>;
								if((jQuery(document).scrollTop() + jQuery(window).height()) > max && window.showFreshmailPopup == true){
									console.log('FreshMail - form <?php echo $val->form_id; ?> opened after ' + jQuery(window).scrollTop() + 'px scrolled. <?php echo $form_var['per_px'][0].' '.$form_var['per_px'][1]; ?> - ' + max);
									jQuery("#fm_popup_<?php echo $val->form_id; ?>").dialog({ modal: true, resizable: false, draggable: false, autoOpen: false, width: 'auto', dialogClass: 'freshmail_dialog' });
									jQuery("#fm_popup_<?php echo $val->form_id; ?>").parent().css({position: "fixed"}).end().dialog('open');
									jQuery.post(static_var.ajax, {'action': 'popup_show', 'form_id':<?php echo $val->form_id; ?>});
									window.showFreshmailPopup = false;
								}
							});
						});
					</script>
				<?php
				}
			}
			if ($show_popup) {
				if (!$javascript_included) {
					$javascript_included = true; ?>
					<script type="text/javascript">
						jQuery(document).ready(function(){
							jQuery("#fm_popup_<?php echo $val->form_id; ?>").dialog({ modal: true, resizable: false, draggable: false, autoOpen: false, width: 'auto', dialogClass: 'freshmail_dialog' });
							jQuery("#fm_popup_<?php echo $val->form_id; ?>").parent().css({position: "fixed"}).end().dialog('open');
							jQuery.post(static_var.ajax, {'action': 'popup_show', 'form_id':<?php echo $val->form_id; ?>});
						});
					</script>
				<?php
				}
			}
		}
	}

	echo "<!-- END FRESHMAIL POPUPS JAVASCRIPT CODE -->";

}

function fm_add_popup_to_footer()
{
	global $wpdb;
	$results = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'fm_forms', OBJECT);

	foreach ($results as $key => $val) {

		$form_var = unserialize($val->freshmail_form_var);
		$show_popup = true;
		$javascript_included = false;
		$shortcode_atts = ' in_popup="true"';
		if ($form_var['show_in_pop_up'] == "yes") {
			// Don't show pop-ups on mobile phones
			if (isset($form_var['pop_ups_mobile']) and wp_is_mobile()) {
				if ($form_var['pop_ups_mobile'] == "true") {
					$show_popup = false;
				}
			}
			// Don't show on specified UTM ta
			if (isset($form_var['dont_show_utm2'])) {
				if (isset($_GET[$form_var['dont_show_utm2']])) {
					if ($_GET[$form_var['dont_show_utm2']] == $form_var['dont_show_utm_value']) {
						$show_popup = false;
					}
				}
			}

			// The maximum number of pop-up displays per user
			if (isset($_SESSION['fm_form_popup'][$val->form_id]['count']) and $form_var['max_popups_number']) {
				if ($_SESSION['fm_form_popup'][$val->form_id]['count'] >= $form_var['max_popups_number']) {
					$show_popup = false;
				}
			}
			if (isset($_SESSION['fm_form_popup'][$val->form_id]['lasttime'])) {
				if ((time() - $_SESSION['fm_form_popup'][$val->form_id]['lasttime']) <= $form_var['lag_time']) {
					$show_popup = false;
				}
			}

			if ($form_var['redirection'] != "no") {
				if ($form_var['redirection'] == "wordpress") {
					$shortcode_atts .= ' redirect="'.$form_var['redirection_wp'].'"';
				}
				if ($form_var['redirection'] == "custom") {
					$shortcode_atts .= ' redirect="'.$form_var['redirection_custom'].'"';
				}
			}

			if ($show_popup) {	?>

				<!-- FRESHMAIL POPUPS -->
				<div id="fm_popup_<?php echo $val->form_id; ?>" class="freshmail_popup">
					<?php echo do_shortcode('[FM_form'.$shortcode_atts.' id="'.$val->form_id.'"]'); ?>
				</div>
				<div class="fm_popup_pos">&nbsp;</div>
				<!-- END FRESHMAIL POPUPS -->

			<?php
			}
		}
	}
}

add_action('wp_ajax_popup_show', 'fm_popup_show_ajax_func');
function fm_popup_show_ajax_func()
{
	if (!session_id()) {
		session_start();
	}
	$_SESSION['fm_form_popup'][$_POST['form_id']]['lasttime'] = time();
	if (!isset($_SESSION['fm_form_popup'][$_POST['form_id']]['count'])) {
		$_SESSION['fm_form_popup'][$_POST['form_id']]['count'] = 1;
	} else {
		$_SESSION['fm_form_popup'][$_POST['form_id']]['count']++;
	}

	die(json_encode($_SESSION['fm_form_popup']));
}