<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

function fm_multisite_form_default_fields()
{
	global $fm_settings;
	if (!isset($fm_settings['fm_sign_up_checkboxes']['freshmail_list_id']) or empty($fm_settings['fm_sign_up_checkboxes']['freshmail_list_id'])) {
		return;
	}

	echo '<p class="comment-form-fm-sign"><label for="fm-sign"><input id="fm-sign" name="fm-sign" type="checkbox" '.($fm_settings['fm_sign_up_checkboxes']['fm_default_selected'] == "yes" ? 'checked' : '').' /> '.$fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form_txt'].'</label><input type="hidden" name="fm-sign-referer" value="'.$_SERVER['REQUEST_URI'].'" /></p>';

	return '';
}

function fm_multisite_form_default_fields_save_meta_data($user_id)
{
	global $fm_settings;

	$user = get_userdata($user_id);

	if (!is_object($user)) {
		return false;
	}

	$email = $user->user_email;
	$name = $user->first_name.' '.$user->last_name;

	return addEmailToDb($email, array('name' => $name), $_POST['fm-sign-referer'], __('Multisite Form', 'wp_freshmail'), $fm_settings['fm_sign_up_checkboxes']['freshmail_list_id']);
}

function fm_multisite_form_default_fields_save_meta_data_meta($meta = array())
{
	global $fm_settings;

	// was sign-up checkbox checked?
	if ($_POST['fm-sign'] == "on") {
		$meta['_freshmail_subscribe'] = 1;
	} else {
		$meta['_freshmail_subscribe'] = 0;
	}

	return $meta;
}

function fm_multisite_form_default_fields_save_meta_data_hidden_checkbox()
{
	// was sign-up checkbox checked?
	if ($_POST['fm-sign'] == "on") {
		$value = 1;
	} else {
		$value = 0;
	}
	?><input type="hidden" name="_freshmail_subscribe" value="<?php echo $value; ?>" /><?php
}

function fm_multisite_form_default_fields_on_multisite_blog_signup($blog_id, $user_id, $a, $b, $meta = null)
{
	// was sign-up checkbox checked?
	if (!isset($meta['_freshmail_subscribe']) || $meta['_freshmail_subscribe'] !== 1) {
		return false;
	}

	return fm_multisite_form_default_fields_save_meta_data($user_id);
}

function fm_multisite_form_default_fields_on_multisite_user_signup($user_id, $password = null, $meta = array())
{
	// abandon if sign-up checkbox was not checked
	if (!isset($meta['_freshmail_subscribe']) || $meta['_freshmail_subscribe'] !== 1) {
		return false;
	}

	return fm_multisite_form_default_fields_save_meta_data($user_id);
}