<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('admin_menu', 'menu_freshmail_add_new_form', 12);
function menu_freshmail_add_new_form()
{
	add_submenu_page('freshmail_slug', __('Sign Up Forms', 'wp_freshmail'), __('Add New Form', 'wp_freshmail'), 'manage_options', 'freshmail_add_new_form', 'render_add_new_form');
}

global $tabs;
$tabs = array(
	'properties' => __('Properties', 'wp_freshmail'),
	'appearance' => __('Appearance', 'wp_freshmail'),
	'messages' => __('Messages', 'wp_freshmail'),
	'list_fields' => __('List & Fields', 'wp_freshmail')
);

function render_add_new_form()
{
	global $fresh_connected;
	global $tabs;
	global $wpdb;

	if ($fresh_connected) {
		if (isset($_GET['form_id'])) {
			global $form_value;
			$form_value = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'fm_forms WHERE form_id = "'.$_GET['form_id'].'";');
			$form_value = unserialize($form_value->freshmail_form_var);
		} ?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Forms', 'wp_freshmail'); ?></h1>

			<?php freshmail_notice();
			$view = empty($_GET['view']) ? (!isset($_GET['form_id']) ? 'list_fields' : 'properties') : $_GET['view'];

			if (isset($_GET['form_id'])) {
				add_new_form_tabs($view);
			}

			echo '<form method="post" id="fm_form" form_id="'.(isset($_GET['form_id']) ? $_GET['form_id'] : 0).'">';
			foreach ($tabs as $key => $val) {
				if ($key == $view) {
					echo '<div class="tabs" id="'.$key.'">';
				} else {
					echo '<div class="tabs" style="display:none;" id="'.$key.'">';
				}
				call_user_func("render_view_".$key);
				echo '</div>';
			}
			echo "</form>";

			include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php } else { ?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Forms', 'wp_freshmail'); ?></h1>
			<h2><?php _e('Please connect to your FreshMail account on the <a href="admin.php?page=freshmail_slug">Connect Page</a>.', 'wp_freshmail'); ?></h2>
			<?php include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php
	}
}

function add_new_form_tabs($current)
{
	global $tabs;

	if (!isset($_GET['form_id'])) {
		$_GET['form_id'] = '';
	}
	echo '<div id="icon-themes" class="icon32"><br></div>';
	echo '<h2 class="nav-tab-wrapper">';
	foreach ($tabs as $tab => $name) {
		$class = ($tab == $current) ? ' nav-tab-active' : null;
		echo '<a class="nav-tab'.$class.'" href="admin.php?page='.$_GET['page'].'&view='.$tab.'&form_id='.$_GET['form_id'].'" onclick="jQuery(".nav-tab-active").removeClass("nav-tab-active");jQuery(this).addClass("nav-tab-active");jQuery(".tabs").hide();jQuery("#$tab").show();jQuery("#fm_form").attr("action",jQuery(this).attr("href"));return false;">'.$name.'</a>';
	}
	echo '</h2>';
}

function render_view_list_fields()
{
	global $form_value;
	include_once(WP_FRESHMAIL_DIR.'/themes/sign_up_forms_view_list_fields.inc.php');
}

function render_view_properties()
{
	global $form_value;
	include_once(WP_FRESHMAIL_DIR.'/themes/sign_up_forms_view_properties.inc.php');
}

function render_view_appearance()
{
	global $form_value;
	include_once(WP_FRESHMAIL_DIR.'/themes/sign_up_forms_view_appearance.inc.php');
}

function render_view_messages()
{
	global $form_value;
	include_once(WP_FRESHMAIL_DIR.'/themes/sign_up_forms_view_messages.inc.php');
}