<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('admin_menu', 'menu_freshmail_items_forms', 11);
function menu_freshmail_items_forms()
{
	add_submenu_page('freshmail_slug', __('All forms', 'wp_freshmail'), __('All forms', 'wp_freshmail'), 'manage_options', 'freshmail_all_forms', 'render_view_forms');
}

function render_view_forms()
{
	global $fresh_connected;

	if ($fresh_connected) {	?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Forms', 'wp_freshmail'); ?>
				<a class="add-new-h2" href="admin.php?page=freshmail_add_new_form"><?php _e('Add New Form', 'wp_freshmail'); ?></a></h1>
			<?php fm_delete_form_id_notices();
			render_view_forms_get_table();
			include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php } else { ?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Forms', 'wp_freshmail'); ?></h1>
			<h2><?php _e('Please connect to your FreshMail account on the <a href="admin.php?page=freshmail_slug">Connect Page</a>.', 'wp_freshmail'); ?></h2>
			<?php include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php
	}
}

function render_view_forms_get_table()
{
	global $wpdb;

	$FM_Forms_List_Table = new FM_Forms_List_Table(array('singular' => 'freshmail_forms', 'plural' => 'freshmail_forms', 'ajax' => false));
	$FM_Forms_List_Table->_column_headers = array(
		array(
			'fm_form' => __('Form', 'wp_freshmail'),
			'fm_contact_list' => __('Contact List', 'wp_freshmail'),
			'fm_number_of_subscribers' => __('Number of Subscribers', 'wp_freshmail'),
			'fm_pop_up' => __('Pop-up', 'wp_freshmail'),
			'fm_shortcode' => __('Shortcode', 'wp_freshmail'),
			'fm_last_edited' => __('Last edited', 'wp_freshmail'),
		),
		array(),
		array(
			'fm_form' => __('Form', 'wp_freshmail'),
			'fm_number_of_subscribers' => __('Number of Subscribers', 'wp_freshmail'),
			'fm_last_edited' => __('Last edited', 'wp_freshmail'),
		),
	);

	$items = array();
	$results = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'fm_forms', OBJECT);
	foreach ($results as $val) {

		$freshmail_form_var = unserialize($val->freshmail_form_var);
		$fm_number_of_subscribers = $wpdb->get_var('SELECT COUNT(*) FROM '.$wpdb->prefix.'fm_forms where form_id='.$val->form_id);
		$items[] = array(
			'ID' => $val->form_id,
			'fm_form' => '<a href="admin.php?page=freshmail_add_new_form&form_id='.$val->form_id.'">'.__('Sign Up Form', 'wp_freshmail').' #'.$val->form_id."</a>",
			'fm_contact_list' => (empty($val->freshmail_list_name) ? '<a style="color:red;" href="admin.php?page=freshmail_add_new_form&form_id='.$val->form_id.'">'.__('No list selected yet', 'wp_freshmail')."</a>" : $val->freshmail_list_name),
			'fm_number_of_subscribers' => $fm_number_of_subscribers,
			'fm_pop_up' => ucwords($freshmail_form_var['show_in_pop_up']),
			'fm_shortcode' => '<input type="text" value=\'[FM_form id="'.$val->form_id.'"]\' />',
			'fm_last_edited' => $val->last_edited
		);
	}

	$FM_Forms_List_Table->items = $items;
	$FM_Forms_List_Table->display(); ?>
	<p><?php _e('Drag & drop the FreshMail Form to the sidebar on the <a href="widgets.php">Appearance > Widgets</a> page.', 'wp_freshmail'); ?></p>
	<p><?php _e('Use a shortcode, for example: <input type="text" value="[FM_form id=&quot;1&quot;]" /> to display the selected form inside a post, page or text widget.', 'wp_freshmail'); ?></p>
<?php
}

if (!class_exists('WP_List_Table')) {
	require_once(ABSPATH.'wp-admin/includes/class-wp-list-table.php');
}

require_once(WP_FRESHMAIL_DIR.'/include/class_wp_list.php');
class FM_Forms_List_Table extends Custom_List_Table
{
	public function __construct($array)
	{
		parent::__construct($array);
	}

	public function column_default($item, $column_name)
	{
		return $item[$column_name];
	}

	public function column_fm_form($item)
	{
		$actions = array(
			'edit' => sprintf('<a href="?page=%s&form_id=%s">'.__('Edit Form', 'wp_freshmail').'</a>', 'freshmail_add_new_form', $item['ID']),
			'stats' => sprintf('<a href="?page=%s&view=%s&form_id=%s">'.__('Stats', 'wp_freshmail').'</a>', $_GET['page'], 'stats', $item['ID']),
			'duplicate' => sprintf('<a href="?page=%s&view=%s&form_id=%s">'.__('Duplicate', 'wp_freshmail').'</a>', $_GET['page'], 'Duplicate', $item['ID']),
			'delete' => sprintf('<a href="?page=%s&delete_form_id=%s">'.__('Delete', 'wp_freshmail').'</a>', $_GET['page'], $item['ID']),
		);

		return sprintf('%1$s %2$s', $item['fm_form'], $this->row_actions($actions));
	}
}