<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('admin_menu', 'menu_freshmail_items_checkboxes_forms', 13);
function menu_freshmail_items_checkboxes_forms()
{
	add_submenu_page('freshmail_slug', __('Checkboxes', 'wp_freshmail'), __('Checkboxes', 'wp_freshmail'), 'manage_options', 'freshmail_checkboxes', 'render_view_checkboxes');
}

function render_view_checkboxes()
{
	global $fm_settings;
	global $fresh_connected;
	if (isset($_POST['sign_up_checkboxes'])) {
		$fm_settings['fm_sign_up_checkboxes'] = $_POST;
	}

	if ($fresh_connected) {
		?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Checkboxes', 'wp_freshmail'); ?></h1>

			<?php fm_delete_form_id_notices(); ?>

			<p>
				<?php _e('Thanks to this function you can easily add a checkbox to different forms so users can sign up for a newsletter while completing other actions on the website, for example while commenting.', 'wp_freshmail'); ?>
			</p>
			<?php
			echo '<form method="post">';
			?>
			<p>
				<table>
					<tr>
						<th valign="top"><?php _e('Select a FreshMail List', 'wp_freshmail'); ?></th>
						<td>
							<select id="freshmail_list_id" name="freshmail_list_id"
							        onchange="if(jQuery(this).val() != '') { jQuery('.fm_hidden').show(); } else { jQuery('.fm_hidden').hide(); } ">
								<option value=""><?php _e('Select...', 'wp_freshmail'); ?></option>
								<?php
								global $rest;
								$rest = new FmRestAPI();
								$rest->setApiKey(FM_API_KEY);
								$rest->setApiSecret(FM_API_SECRET);

								try {
									$response = $rest->doRequest('subscribers_list/lists');
									foreach ($response['lists'] as $key => $val) {
										echo '<option value="'.$val['subscriberListHash'].'" '.(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['freshmail_list_id'] == $val['subscriberListHash'] ? 'selected' : '') : '').'>'.$val['name'].'</option>';
									}
								} catch (Exception $e) {
								}
								?>
							</select><br/><br/>
							<?php _e('Select the recipients list to which you would like to add new email addresses', 'wp_freshmail'); ?>
						</td>
					</tr>
				</table>
			</p>

			<div class="fm_hidden" <?php if (isset($fm_settings['fm_sign_up_checkboxes']['freshmail_list_id'])) { ?>style="display:block;"<?php } ?>>
				<h2 class="nav-tab-wrapper"><?php _e('Checkbox Settings', 'wp_freshmail'); ?></h2>

				<p>
					<?php _e('Select where you want to add checkboxes (find out which plug-ins could be integrated with ours). <br />Customise checkbox label text. HTML tags like  <span class="fm_code">&lt;strong&gt; &lt;em&gt; &lt;a&gt;</span> are allowed.', 'wp_freshmail'); ?>
				</p>

				<p>
					<table class="wp-list-table widefat" style="width:700px;border:1px solid #eee;">
						<tr>
							<th class="manage-column column-name" id="name" scope="col" style="border-bottom:1px solid #eee;width:250px;"><?php _e('Form', 'wp_freshmail'); ?></th>
							<th class="manage-column column-name" id="name" scope="col"
							    style="border-bottom:1px solid #eee;width:450px;"><?php _e('Checkbox label text', 'wp_freshmail'); ?></th>
						</tr>
						<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input type="checkbox"
								       name="sign_up_checkboxes[comment_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['comment_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('Comment Form', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" type="text" name="sign_up_checkboxes[comment_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['comment_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['comment_form_txt'] : __('Yes, sign me up for the free newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input type="checkbox"
								       name="sign_up_checkboxes[reg_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['reg_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('Registration Form', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" type="text" name="sign_up_checkboxes[reg_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['reg_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['reg_form_txt'] : __('Yes, sign me up for the free newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php if (class_exists('woocommerce')) { ?>
							<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input <?php echo(!class_exists('woocommerce') ? 'disabled' : ''); ?> type="checkbox"
								                                                                      name="sign_up_checkboxes[woo_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['woo_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('WooCommerce Checkout', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" <?php echo(!class_exists('woocommerce') ? 'disabled' : ''); ?> type="text" name="sign_up_checkboxes[woo_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['woo_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['woo_form_txt'] : __('Yes, sign me up for the free newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php } ?>
						<?php if (class_exists('EDD_API')) { ?>
							<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input <?php echo(!class_exists('EDD_API') ? 'disabled' : ''); ?> type="checkbox"
								                                                                  name="sign_up_checkboxes[easy_dig_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['easy_dig_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('Easy Digital Download Checkout', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" <?php echo(!class_exists('EDD_API') ? 'disabled' : ''); ?> type="text" name="sign_up_checkboxes[easy_dig_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['easy_dig_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['easy_dig_form_txt'] : __('Yes, sign me up for the free newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php } ?>
						<?php if (class_exists('bbpress')) { ?>
							<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input <?php echo(!class_exists('bbpress') ? 'disabled' : ''); ?> type="checkbox"
								                                                                  name="sign_up_checkboxes[bbpress_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['bbpress_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('bbPress', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" <?php echo(!class_exists('bbpress') ? 'disabled' : ''); ?> type="text" name="sign_up_checkboxes[bbpress_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['bbpress_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['bbpress_form_txt'] : __('Yes, sign me up for the newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php } ?>
						<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input type="checkbox"
								       name="sign_up_checkboxes[multisite_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('MultiSite Forms', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" type="text" name="sign_up_checkboxes[multisite_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['multisite_form_txt'] : __('Yes, sign me up for the forum newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php if (class_exists('BuddyPress')) { ?>
							<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input <?php echo(!class_exists('BuddyPress') ? 'disabled' : ''); ?> type="checkbox"
								                                                                     name="sign_up_checkboxes[buddypress_form]" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['buddypress_form'] == 'on' ? 'checked' : '') : ''); ?> />
								<?php _e('BuddyPress registration', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input style="width:100%;" <?php echo(!class_exists('BuddyPress') ? 'disabled' : ''); ?> type="text" name="sign_up_checkboxes[buddypress_form_txt]"
								       value="<?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['buddypress_form_txt'])) ? $fm_settings['fm_sign_up_checkboxes']['sign_up_checkboxes']['buddypress_form_txt'] : __('Yes, sign me up for the forum newsletter!', 'wp_freshmail')); ?>"/>
							</td>
						</tr>
						<?php } ?>
						<?php if (function_exists('wpcf7_add_shortcode')) { ?>
							<tr>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<input type="checkbox" checked disabled/>
								<?php _e('Contact form 7', 'wp_freshmail'); ?>
							</td>
							<td style="" class="manage-column column-name" id="name" scope="col">
								<?php _e('Use shortcode in your Contact Form 7 mark-up to add a sign-up checkbox to your CF7 forms', 'wp_freshmail'); ?><br/>
								<input type="text" value="[FM_checkbox label=&quot;Label text&quot;]" style="width:230px;">
							</td>
						</tr>
						<?php } ?>
					</table>
				</p>


				<p>
					<table>
						<tr>
							<th valign="top"><?php _e('Default checkbox selected?', 'wp_freshmail'); ?></th>
							<td>
								<input type="radio" name="fm_default_selected"
								       value="yes" <?php echo((isset($fm_settings['fm_sign_up_checkboxes']) and !empty($fm_settings['fm_sign_up_checkboxes']['fm_default_selected'])) ? ($fm_settings['fm_sign_up_checkboxes']['fm_default_selected'] == 'yes' ? 'checked' : '') : 'checked'); ?> /> <?php _e('Yes', 'wp_freshmail'); ?>
								<br/><br/>
								<input type="radio" name="fm_default_selected"
								       value="no" <?php echo(isset($fm_settings['fm_sign_up_checkboxes']) ? ($fm_settings['fm_sign_up_checkboxes']['fm_default_selected'] == 'no' ? 'checked' : '') : ''); ?> /> <?php _e('No', 'wp_freshmail'); ?>
							</td>
						</tr>
					</table>
				</p>
			</div>

			<p>
				<input type="submit" value="<?php _e('Save changes', 'wp_freshmail'); ?>" title="" class="button button_fm" id="freshmail_submit" name="freshmail_submit"/>
			</p>
			<?php
			echo "</form>";

			include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php');
			?>
		</div>
	<?php
	} else {
		?>
		<div class="wrap freshmail">
			<h1><?php _e('Sign Up Checkboxes', 'wp_freshmail'); ?></h1>

			<h2><?php _e('Please connect to your FreshMail account on the <a href="admin.php?page=freshmail_slug">Connect Page</a>.', 'wp_freshmail'); ?></h2>
			<?php include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php
	}
}

add_action("init", "freshmailSingUpCheckboxes", 6);
function freshmailSingUpCheckboxes()
{
	if (isset($_POST['sign_up_checkboxes'])) {
		global $fm_notice;
		$fm_notice .= '<div class="fm_updated"><p>'.__('The Sign Up Checkboxes has been updated!', 'wp_freshmail').'</p></div>';
		update_option('fm_sign_up_checkboxes', $_POST);
	}
}