<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('admin_menu', 'menu_freshmail_items_init', 9);
function menu_freshmail_items_init()
{
	add_menu_page(__('FreshMail', 'wp_freshmail'), __('FreshMail', 'wp_freshmail'), 'manage_options', 'freshmail_slug', 'render_freshmail', WP_FRESHMAIL_URL.'/assets/images/icon.png');
}

add_action('admin_menu', 'menu_freshmail_items_connect', 15);
function menu_freshmail_items_connect()
{
	remove_submenu_page('freshmail_slug', 'freshmail_slug');
	add_submenu_page('freshmail_slug', __('Connect', 'wp_freshmail'), __('Connect', 'wp_freshmail'), 'manage_options', 'freshmail_slug', 'render_freshmail');
}

function render_freshmail()
{
	global $fresh_connected;

	if ($fresh_connected) {	?>
		<div class="wrap freshmail">
			<h1><?php _e('Connected to FreshMail', 'wp_freshmail'); ?></h1>

			<h2>
				<?php _e('Logged to FreshMail account.', 'wp_freshmail'); ?>
				<form method="post"><input type="submit" class="button button_fm" value="<?php _e('Log Out', 'wp_freshmail'); ?>" name="freshmail_logout"/></form>
			</h2>
			<?php include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php } else { ?>
		<div class="wrap freshmail">
			<h1><?php _e('Connecting to FreshMail', 'wp_freshmail'); ?></h1>
			<h2><?php _e('Hello! Start using this plug-in by connecting to your FreshMail account. Find out <a href="http://freshmail.com/help-and-knowledge/help/account-settings/what-is-an-api-key-and-where-can-you-find-it/" target="_blank">where to find API Keys</a>.', 'wp_freshmail'); ?></h2>
			<form method="post">
				<h2>
					<label for="freshmail_api_key" class="freshmail_api">
						<span><?php _e('API Key', 'wp_freshmail'); ?></span>
						<input type="text" value="<?php echo FM_API_KEY; ?>" title="" class="" id="freshmail_api_key" name="freshmail_api_key" required/>
					</label>
				</h2>
				<h2>
					<label for="freshmail_api_secret_key" class="freshmail_api">
						<span><?php _e('API Secret Key', 'wp_freshmail'); ?></span>
						<input type="text" value="<?php echo FM_API_SECRET; ?>" title="" class="" id="freshmail_api_secret_key" name="freshmail_api_secret_key" required/>
					</label>
				</h2>
				<h2>
					<label for="freshmail_api_key_submit" class="freshmail_api">
						<span>&nbsp;</span>
						<input type="submit" value="<?php _e('Save changes', 'wp_freshmail'); ?>" title="" class="button button_fm" id="freshmail_api_key_submit" name="freshmail_api_key_submit"/>
					</label>
				</h2>
				<?php global $fresh_connected_error;
				if($fresh_connected_error != null){ ?>
					<h2 style="color: #b94a48; background-color: #f2dede; border-color: #eed3d7; border-radius: 4px; padding-left :5px;">
						<label class="freshmail_api">
							<span><?php echo $fresh_connected_error; ?>!</span>
							<?php if(strpos(($fresh_connected_error), 'autoryzacji')) {
							  _e('Check your API key and API Secret Key <a href="https://app.freshmail.com/en/settings/integration/">here</a>', 'wp_freshmail');
							}	?>
						</label>
					</h2>
				<?php } ?>
			</form>
			<div class="donthaveaccount">
				<span><?php _e('You don\'t have a FreshMail account yet?', 'wp_freshmail'); ?></span>
				<p><?php _e('<a href="http://freshmail.com/" target="_blank">FreshMail</a> is an email marketing tool for creating and sending amazing newsletters. Our intuitive system leads users from campaign planning and creation to final reports.', 'wp_freshmail'); ?></p>
				<p><?php _e('A free account lets you send up to 2000 messages to a maximum of 500 recipients each month.', 'wp_freshmail'); ?></p>
				<p><?php _e('<a href="https://app.freshmail.com/#register-tab" target="_blank" class="button button_fm">Sign Up For Free!</a> or <a href="http://freshmail.com">Learn more</a>', 'wp_freshmail'); ?></p>
				<p><?php _e('No credit card required', 'wp_freshmail'); ?></p>
			</div>
			<?php include_once(WP_FRESHMAIL_DIR.'/themes/bottom.inc.php'); ?>
		</div>
	<?php }
}

add_action('init', 'freshmail_api_key_update_func', 4);
function freshmail_api_key_update_func()
{
	if (count($_POST)) {
		if (!empty($_POST['freshmail_api_secret_key']) and !empty($_POST['freshmail_api_key'])) {
			$apiKey = trim($_POST['freshmail_api_key']);
			$secretKey = trim($_POST['freshmail_api_secret_key']);
			update_option('freshmail_api_secret_key', $secretKey);
			update_option('freshmail_api_key', $apiKey);

			if (!defined('FM_API_KEY')) {
				define ('FM_API_KEY', $apiKey);
			}
			if (!defined('FM_API_SECRET')) {
				define ('FM_API_SECRET', $secretKey);
			}

			global $fresh_connected;
			connectToFreshMail(true);
			if ($fresh_connected) {
				update_option('freshmail_api_connected', 'true');
			}
		}

		if (!empty($_POST['freshmail_logout'])) {
			delete_option('freshmail_api_connected');
			// TO DO - admin_notice
		}
	}
}