<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

class FreshmailWidget extends WP_Widget
{

	function FreshmailWidget()
	{
		parent::WP_Widget(false, $name = __('FreshMail', 'wp_freshmail'), array('description' => __('A widget that displays the FreshMail sign up Forms', 'wp_freshmail')));
	}

	function widget($args, $instance)
	{
		extract($args);

		$title = apply_filters('widget_title', $instance['title']);

		echo $before_widget;

		if (isset($instance['form_id'])) {
			echo do_shortcode('[FM_form id="'.$instance['form_id'].'"]');
		}

		echo $after_widget;
	}

	function update($new_instance, $old_instance)
	{
		$instance = $old_instance;

		$instance['title'] = $new_instance['title'];
		$instance['form_id'] = $new_instance['form_id'];

		return $instance;
	}

	function form($instance)
	{
		global $wpdb;
		$results = $wpdb->get_results('SELECT form_id FROM '.$wpdb->prefix.'fm_forms', OBJECT);

		$instance = wp_parse_args((array)$instance, array('title' => __('newsletter', 'wp_freshmail'))); ?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'wp_freshmail'); ?></label>
			<input type="text" name="<?php echo $this->get_field_name('title') ?>" id="<?php echo $this->get_field_id('title') ?> " value="<?php echo $instance['title'] ?>" size="20"/>
		</p>
		<?php
		echo '<p>';
		if (count($results)) {
			echo "<label for='".$this->get_field_id('form_id')."'>".__('Sign Up Form', 'wp_freshmail')."</label><br /><select name='".$this->get_field_name('form_id')."'>";
			foreach ($results as $key => $val) {
				echo "<option value='".$val->form_id."' ".($val->form_id == $instance['form_id'] ? 'selected' : '').">".__('Sign Up Form', 'wp_freshmail').' #'.$val->form_id."</option>";
			}
			echo "</select>";
		} else {
			echo '<p class="no-options-widget">'.__('There are no form. <a href="admin.php?page=freshmail_add_new_form">Add first</a>.', 'wp_freshmail').'</p>';
		}
		echo "</p>";

		return '';
	}
}

function freshmailRegisterWidgets()
{
	register_widget('FreshmailWidget');
}

add_action('widgets_init', 'freshmailRegisterWidgets');