<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('wp_ajax_get_freshmail_fields', 'get_freshmail_fields_ajax_func');

function get_freshmail_fields_ajax_func()
{
	if (!isset($_POST['list_hash']) or empty($_POST['list_hash'])) {
		die('<div style="padding:5px">'.__('Select a FreshMail List to view fields.', 'wp_freshmail').'</div>');
	} ?>
	<tr>
		<th><?php _e('Field name', 'wp_freshmail'); ?></th>
		<th><?php _e('Text on the Form', 'wp_freshmail'); ?></th>
		<th><?php _e('Placeholder on the Form', 'wp_freshmail'); ?></th>
		<th><?php _e('Required', 'wp_freshmail'); ?></th>
		<th><?php _e('Include', 'wp_freshmail'); ?></th>
	</tr>
	<?php global $form_value, $rest;

	$rest = new FmRestAPI();
	$rest->setApiKey(FM_API_KEY);
	$rest->setApiSecret(FM_API_SECRET);

	try {
		$postdata = array('hash' => $_POST['list_hash']);
		$response = $rest->doRequest('subscribers_list/getFields', $postdata);?>
		<tr>
			<td><?php _e('Email', 'wp_freshmail'); ?></td>
			<td>
				<input type="text" placeholder="<?php _e('Email', 'wp_freshmail'); ?>" name="fm_form_var[fields][email][value]" value="<?php echo(is_array($form_value) ? $form_value['fields']['email']['value'] : __('Email', 'wp_freshmail')); ?>" />
			</td>
			<td>
				<input type="text" placeholder="<?php _e('Email', 'wp_freshmail'); ?>" name="fm_form_var[fields][email][placeholder]" value="<?php _e('Email', 'wp_freshmail'); ?>" />
			</td>
			<td>
				<input type="checkbox" checked="yes" name="fm_form_var[fields][email][required]" <?php echo(is_array($form_value) ? ($form_value['fields']['email']['required'] == 'on' ? 'checked' : '') : 'checked'); ?> style="display:none" /><input type="checkbox" disabled checked />
			</td>
			<td>
				<input type="checkbox" checked="yes" name="fm_form_var[fields][email][include]" <?php echo(is_array($form_value) ? ($form_value['fields']['email']['include'] == 'on' ? 'checked' : '') : 'checked'); ?> style="display:none" /><input type="checkbox" disabled checked />
			</td>
		</tr>
		<?php foreach ($response['fields'] as $val): ?>
			<tr>
				<td><?php echo $val['name']; ?></td>
				<td>
					<input type="text" placeholder="<?php echo $val['name']; ?>" name="fm_form_var[fields][<?php echo $val['tag']; ?>][value]" value="<?php echo(is_array($form_value) ? $form_value['fields'][$val['tag']]['value'] : $val['name']); ?>" />
					<input type="hidden" name="fm_form_var[fields][<?php echo $val['tag']; ?>][hash]" value="<?php echo $val['hash']; ?>" />
				</td>
				<td>
					<input type="text" placeholder="<?php echo $val['name']; ?>" name="fm_form_var[fields][<?php echo $val['tag']; ?>][placeholder]" value="<?php echo $val['name'] ?>" />
				</td>
				<td>
					<input type="checkbox" name="fm_form_var[fields][<?php echo $val['tag']; ?>][required]" <?php echo(is_array($form_value) ? ($form_value['fields'][$val['tag']]['required'] == 'on' ? 'checked' : '') : 'checked'); ?>/>
				</td>
				<td>
					<input type="checkbox" name="fm_form_var[fields][<?php echo $val['tag']; ?>][include]" <?php echo(is_array($form_value) ? ($form_value['fields'][$val['tag']]['include'] == 'on' ? 'checked' : '') : 'checked'); ?>/>
				</td>
			</tr>
		<?php endforeach;
	} catch (Exception $e) {
		echo 'Error message: '.$e->getMessage().', Error code: '.$e->getCode().', HTTP code: '.$rest->getdttpCode().PHP_EOL;
	}
	exit;
}