<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('wp_ajax_preview_form', 'fm_preview_form_func');
add_action('wp_ajax_nopriv_preview_form', 'fm_preview_form_func');

function fm_preview_form_func()
{
	echo do_shortcode('[FM_form id="'.$_POST['form_id'].'"]');
	exit;
}

add_action('wp_ajax_fm_form', 'fm_form_ajax_func');
add_action('wp_ajax_nopriv_fm_form', 'fm_form_ajax_func');

function fm_form_ajax_func()
{
	global $wpdb;
	global $rest;
	initFreshMailVariable();

	if (!is_object($rest)) {
		include_once(WP_FRESHMAIL_DIR.'/include/class.rest.php');
		$rest = new FmRestAPI();
		$rest->setApiKey(FM_API_KEY);
		$rest->setApiSecret(FM_API_SECRET);
	}

	$result = $_POST;

	if (!isset($result['redirect'])) {
		$result['redirect'] = 0;
	}

	$form = $wpdb->get_row('select * from '.$wpdb->prefix.'fm_forms where form_id="'.$result['fm_form_id'].'";');
	$form_value = unserialize($form->freshmail_form_var);
	$result['status'] = 'success';
	$result['message'] = $form_value['messages']['success'];

	foreach ($form_value['fields'] as $key => $val) {
		if (is_array($val)) {
			if ($val['include'] == "on" && $val['required'] == "on") {
				if (empty($result['form'][$key])) {
					$result['status'] = 'error';
					$result['message'] = $form_value['messages']['required'];
				}
			}
		}
	}

	if (!filter_var($result['form']['email'], FILTER_VALIDATE_EMAIL)) {
		$result['status'] = 'error';
		$result['message'] = $form_value['messages']['invalid'];
	}

	if ((!isset($_POST['fm_form_agree']) or $_POST['fm_form_agree'] != 'on') and $form_value['appearance']['checkbox_agreement']['display'] == "yes") {
		$result['status'] = 'error';
		$result['message'] = $form_value['messages']['required'];
	}

	if ($result['status'] == 'success') {

		$checkMailIdExists = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'fm_mails WHERE email="'.$result['form']['email'].'";');
		if (empty($checkMailIdExists)) {
			if (!$wpdb->insert(
				$wpdb->prefix.'fm_mails',
				array(
					'email' => $result['form']['email'],
					'ext_fields' => serialize($result['form']),
					'form_id' => $result['fm_form_id'],
					'referer' => $result['fm_form_referer']
				),
				array('%s', '%s', '%s', '%s')
			)
			) {
				$result['status'] = 'error';
				$result['message'] = $form_value['messages']['failure'];
			}
		}


		if (!$wpdb->insert_id) {
			$result['status'] = 'success';
			$result['message'] = $form_value['messages']['already'];
		} else {

			$custom_fields = array();
			if (count($result['form']) > 1) {
				foreach ($result['form'] as $key => $val) {
					if ($key != "email") {
						$custom_fields[$key] = $val;
					}
				}
			}

			try {
				$postdata = array('email' => $result['form']['email'], 'list' => $form->freshmail_list_id, 'custom_fields' => $custom_fields);
				$response = $rest->doRequest('subscriber/add', $postdata);
			} catch (Exception $e) {
				// uncomment only when developing!
				//	print_r($e);
			}

		}

	}

	die(json_encode($result));
}