<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */
?><p>
	<?php _e('Select the recipient list to which you would like to add the new subscribers gained from the sign-up form.', 'wp_freshmail'); ?>
</p>

<p>
	<label for="select_freshmail_list">
		<strong><?php _e('Select a FreshMail List', 'wp_freshmail'); ?></strong>
		<select id="select_freshmail_list" name="fm_form_var[select_freshmail_list_id]" onchange="get_freshmail_fields(jQuery(this).val());">
			<option value=""><?php _e('Select...', 'wp_freshmail'); ?></option>
			<?php
			global $rest;
			$rest = new FmRestAPI();
			$rest->setApiKey(FM_API_KEY);
			$rest->setApiSecret(FM_API_SECRET);

			try {
				$response = $rest->doRequest('subscribers_list/lists');
				foreach ($response['lists'] as $key => $val) {
					echo '<option value="'.$val['subscriberListHash'].'" '.(is_array($form_value) ? ($form_value['select_freshmail_list_id'] == $val['subscriberListHash'] ? 'selected' : '') : '').'>'.$val['name'].'</option>';
				}

			} catch (Exception $e) { }
			?>
		</select>
	</label>
</p>

<p>
	<?php _e('Mark the fields that a new subscriber must fill in when signing up for a newsletter using the form.', 'wp_freshmail'); ?>
</p>

<p>
	<table id="freshmail_fields" class="widefat">
	<?php if (isset($form_value['select_freshmail_list_id'])) { ?>
		<tr>
			<th><?php _e('Field name', 'wp_freshmail'); ?></th>
			<th><?php _e('Text on the Form', 'wp_freshmail'); ?></th>
			<th><?php _e('Placeholder on the Form', 'wp_freshmail'); ?></th>
			<th><?php _e('Required', 'wp_freshmail'); ?></th>
			<th><?php _e('Include', 'wp_freshmail'); ?></th>
		</tr>

		<?php
		global $rest;
		$rest = new FmRestAPI();
		$rest->setApiKey(FM_API_KEY);
		$rest->setApiSecret(FM_API_SECRET);

		try {
			$postdata = array('hash' => $form_value['select_freshmail_list_id']);
			$response = $rest->doRequest('subscribers_list/getFields', $postdata);

			?>
			<tr>
				<td><?php _e('Email', 'wp_freshmail'); ?></td>
				<td>
					<input type="text" placeholder="<?php _e('Email', 'wp_freshmail'); ?>" name="fm_form_var[fields][email][value]" value="<?php echo(is_array($form_value) ? $form_value['fields']['email']['value'] : __('Email', 'wp_freshmail')); ?>"/>
				</td>
				<td>
					<input type="text" placeholder="<?php _e('Placeholder', 'wp_freshmail'); ?>" name="fm_form_var[fields][email][placeholder]" value="<?php echo(isset($form_value['fields']['email']['placeholder'])) ? $form_value['fields']['email']['placeholder'] : __('Placeholder', 'wp_freshmail'); ?>"/>
				</td>
				<td>
					<input type="checkbox" checked="yes" name="fm_form_var[fields][email][required]" <?php echo(is_array($form_value) ? ($form_value['fields']['email']['required'] == 'on' ? 'checked' : '') : 'checked'); ?> style="display:none"/><input type="checkbox" disabled checked/>
				</td>
				<td>
					<input type="checkbox" checked="yes" name="fm_form_var[fields][email][include]" <?php echo(is_array($form_value) ? ($form_value['fields']['email']['include'] == 'on' ? 'checked' : '') : 'checked'); ?> style="display:none"/><input type="checkbox" disabled checked/>
				</td>
			</tr>
		<?php	foreach ($response['fields'] as $key => $val) {	?>
				<tr>
				<td><?php echo $val['name']; ?></td>
				<td>
					<input type="text" placeholder="<?php echo $val['name']; ?>" name="fm_form_var[fields][<?php echo $val['tag']; ?>][value]" value="<?php echo(is_array($form_value) ? $form_value['fields'][$val['tag']]['value'] : $val['name']); ?>"/>
					<input type="hidden" name="fm_form_var[fields][<?php echo $val['tag']; ?>][hash]" value="<?php echo $val['hash']; ?>"/>
				</td>
					<td>
						<input type="text" placeholder="<?php echo $val['name']; ?>" name="fm_form_var[fields][<?php echo $val['tag']; ?>][placeholder]" value="<?php echo (isset($form_value['fields'][$val['tag']]['placeholder']) ? $form_value['fields'][$val['tag']]['placeholder'] : __('Placeholder', 'wp_freshmail')); ?>"/>
					</td>
				<td><input type="checkbox" name="fm_form_var[fields][<?php echo $val['tag']; ?>][required]" <?php echo(is_array($form_value) ? ($form_value['fields'][$val['tag']]['required'] == 'on' ? 'checked' : '') : 'checked'); ?>/></td>
				<td><input type="checkbox" name="fm_form_var[fields][<?php echo $val['tag']; ?>][include]" <?php echo(is_array($form_value) ? ($form_value['fields'][$val['tag']]['include'] == 'on' ? 'checked' : '') : 'checked'); ?>/></td>
			</tr>
			<?php
			}
		} catch (Exception $e) {
			echo 'Error message: '.$e->getMessage().', Error code: '.$e->getCode().', HTTP code: '.$rest->getHttpCode().PHP_EOL;
		}
	} ?>
</table>

<?php if (!isset($_GET['form_id'])) { ?>
	<script>
		jQuery(document).ready(function($) {
			changeTheme();
		});
	</script>
<?php } ?>

<p>
	<input type="submit" value="<?php _e('Save changes', 'wp_freshmail'); ?>" title="" class="button button_fm freshmail_api_key_submit" id="freshmail_api_key_submit" <?php if (!isset($_GET['form_id'])) { echo 'disabled="disabled" '; } ?>name="freshmail_api_key_submit"/>
</p>