<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

function freshmail_activation()
{
	$old_version = get_option('WP_FRESHMAIL_VERSION');

	if ($old_version != WP_FRESHMAIL_VERSION) {
		freshmail_update_database();
		update_option('WP_FRESHMAIL_VERSION', WP_FRESHMAIL_VERSION);
	}
}

function freshmail_update_database()
{
	delete_option('freshmail_api_key');
	delete_option('freshmail_api_secret_key');
	delete_option('freshmail_api_connected');

	require_once(ABSPATH.'wp-admin/includes/upgrade.php');

	global $wpdb;
	$table = $wpdb->prefix.'fm_mails';
	$sql = "CREATE TABLE IF NOT EXISTS ".$table." (
              mail_id INT(11) NOT NULL AUTO_INCREMENT,
              email VARCHAR(255) NOT NULL DEFAULT '',
              ext_fields TEXT NULL,
              form_id VARCHAR( 100 ) NOT NULL,
              referer VARCHAR( 100 ) NOT NULL,
              insert_date TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
              UNIQUE KEY mail_id ( mail_id),
              UNIQUE KEY email (email)
              ) DEFAULT CHARSET=utf8 ;";

	dbDelta($sql);

	$table = $wpdb->prefix.'fm_forms';
	$sql = "CREATE TABLE IF NOT EXISTS `".$table."` (
              `form_id` INT(11) NOT NULL AUTO_INCREMENT,
              `freshmail_list_id` VARCHAR(50) NOT NULL DEFAULT '',
              `freshmail_list_name` VARCHAR(255) NOT NULL DEFAULT '',
              `freshmail_form_var` text NULL,
              `insert_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
              `last_edited` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
              UNIQUE KEY `form_id` (`form_id`)
              ) DEFAULT CHARSET=utf8 ;";

	dbDelta($sql);

	/*
	 * default themes
	 */
	$default_theme = serialize(array(
		__('Black_and_white', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 300,
				'width2' => 'px',
				'background_color' => '#ffffff',
				'border_color' => '#000000',
				'border_width' => 0,
				'rounded_corners' => 5,
				'padding1' => 0,
				'padding2' => 24,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#000000',
				'text_size' => 18,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#000000',
				'text_size' => 11,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 100,
				'select_width' => 'px',
				'position' => 'clear:left;display:block;',
				'text_color' => '#000000',
				'text_size' => 9,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 100,
				'select_field_width' => '%',
				'height' => 35,
				'select_field_height' => 'px',
				'text_color' => '#000000',
				'text_size' => 12,
				'border_color' => '#b7b7b7',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'checked' => 'no',
				'text_color' => '#000000',
				'text_size' => 9,
				'text_aligment' => 'left',
			),
			'button' => array(
				'width' => 120,
				'select_width' => 'px',
				'height' => 40,
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => 11,
				'text_color' => '#ffffff',
				'background_color' => '#000000',
				'border_color' => '#8c8c8c',
				'border_width' => 0,
				'rounded_corners' => 5,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('Yellow', 'wp_freshmail') => array(
			'name' => '',
			'form_container' => array(
				'width' => 400,
				'width2' => 'px',
				'background_color' => '#fef200',
				'border_color' => '#000000',
				'border_width' => 0,
				'rounded_corners' => 5,
				'padding1' => 5,
				'padding2' => 15,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#000000',
				'text_size' => 20,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#000000',
				'text_size' => 12,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 20,
				'select_width' => '%',
				'position' => 'display:block;float:left;',
				'text_color' => '#0a0a0a',
				'text_size' => 12,
				'select_text_style' => 0,
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 79,
				'select_field_width' => '%',
				'height' => 30,
				'select_field_height' => 'px',
				'text_color' => '#000000',
				'text_size' => 10,
				'border_color' => '#dddddd',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'text_color' => '#000000',
				'text_size' => 10,
				'text_aligment' => 'left',
			),
			'button' => array(
				'width' => 100,
				'select_width' => '%',
				'height' => 40,
				'select_height' => 'px',
				'select_aligment' => 'left',
				'text_size' => 12,
				'text_color' => '#ffffff',
				'background_color' => '#000000',
				'border_color' => '#383838',
				'border_width' => 0,
				'rounded_corners' => 5,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('Grey', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 400,
				'width2' => 'px',
				'background_color' => '#ededed',
				'border_color' => '#000000',
				'border_width' => 1,
				'rounded_corners' => 0,
				'padding1' => 0,
				'padding2' => 20,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#000000',
				'text_size' => 14,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#000000',
				'text_size' => 11,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 100,
				'select_width' => 'px',
				'position' => 'clear:left;display:block;',
				'text_color' => '#000000',
				'text_size' => 9,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 100,
				'select_field_width' => '%',
				'height' => 40,
				'select_field_height' => 'px',
				'text_color' => '#000000',
				'text_size' => 12,
				'border_color' => '#ededed',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'checked' => 'no',
				'text_color' => '#000000',
				'text_size' => 9,
				'text_aligment' => 'left',
			),
			'button' => array(
				'width' => 120,
				'select_width' => 'px',
				'height' => 40,
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => 11,
				'text_color' => '#000000',
				'background_color' => '#ededed',
				'border_color' => '#000000',
				'border_width' => 2,
				'rounded_corners' => 0,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('Blue', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 300,
				'width2' => 'px',
				'background_color' => '#1b3558',
				'border_color' => '#f14231',
				'border_width' => 0,
				'rounded_corners' => 0,
				'padding1' => 0,
				'padding2' => 40,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => 20,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#ffffff',
				'text_size' => 11,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 100,
				'select_width' => 'px',
				'position' => 'clear:left;display:block;',
				'text_color' => '#ffffff',
				'text_size' => 9,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 100,
				'select_field_width' => '%',
				'height' => 30,
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => 11,
				'border_color' => '#b7b7b7',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'yes',
				'checked' => 'no',
				'text_color' => '#9aabb7',
				'text_size' => 9,
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => 120,
				'select_width' => 'px',
				'height' => 40,
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => 11,
				'text_color' => '#ffffff',
				'background_color' => '#f14231',
				'border_color' => '#8c8c8c',
				'border_width' => 0,
				'rounded_corners' => 5,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('White_and_Red', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 300,
				'width2' => 'px',
				'background_color' => '#ffffff',
				'border_color' => '#000000',
				'border_width' => 1,
				'rounded_corners' => 0,
				'padding1' => 0,
				'padding2' => 14,
			),
			'text_header' => array(
				'display' => 'no',
				'text_color' => '#000000',
				'text_size' => 18,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'yes',
				'text_color' => '#000000',
				'text_size' => 13,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 19,
				'select_width' => '%',
				'position' => 'display:block;float:left;',
				'text_color' => '#000000',
				'text_size' => 10,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 80,
				'select_field_width' => '%',
				'height' => 30,
				'select_field_height' => 'px',
				'text_color' => '#000000',
				'text_size' => 12,
				'border_color' => '#b7b7b7',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'checked' => 'no',
				'text_color' => '#000000',
				'text_size' => 9,
				'text_aligment' => 'left',
			),
			'button' => array(
				'width' => 110,
				'select_width' => 'px',
				'height' => 35,
				'select_height' => 'px',
				'select_aligment' => 'right',
				'text_size' => 11,
				'text_color' => '#ffffff',
				'background_color' => '#f14231',
				'border_color' => '#8c8c8c',
				'border_width' => 0,
				'rounded_corners' => 0,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('Green', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 350,
				'width2' => 'px',
				'background_color' => '#36c113',
				'border_color' => '#417d07',
				'border_width' => 0,
				'rounded_corners' => 5,
				'padding1' => 0,
				'padding2' => 20,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => 18,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#417d07',
				'text_size' => 11,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 19,
				'select_width' => '%',
				'position' => 'display:block;float:left;',
				'text_color' => '#ffffff',
				'text_size' => 12,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 80,
				'select_field_width' => '%',
				'height' => 30,
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => 11,
				'border_color' => '#b7b7b7',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'checked' => 'no',
				'text_color' => '#417d07',
				'text_size' => 9,
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => 120,
				'select_width' => 'px',
				'height' => 40,
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => 11,
				'text_color' => '#ffffff',
				'background_color' => '#417d07',
				'border_color' => '#8c8c8c',
				'border_width' => 0,
				'rounded_corners' => 20,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('Black', 'wp_freshmail') => array(
			'form_container' => array(
				'width' => 300,
				'width2' => 'px',
				'background_color' => '#000000',
				'border_color' => '#f14231',
				'border_width' => 0,
				'rounded_corners' => 0,
				'padding1' => 0,
				'padding2' => 40,
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => 20,
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#ffffff',
				'text_size' => 11,
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => 100,
				'select_width' => 'px',
				'position' => 'clear:left;display:block;',
				'text_color' => '#ffffff',
				'text_size' => 9,
				'select_text_style' => 'font-style:normal;',
				'display_labels' => 'yes',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => 100,
				'select_field_width' => '%',
				'height' => 30,
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => 12,
				'border_color' => '#b7b7b7',
				'border_width' => 1,
			),
			'checkbox_agreement' => array(
				'display' => 'yes',
				'checked' => 'no',
				'text_color' => '#c1c1c1',
				'text_size' => 9,
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => 130,
				'select_width' => 'px',
				'height' => 44,
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => 11,
				'text_color' => '#ffffff',
				'background_color' => '#000000',
				'border_color' => '#ffffff',
				'border_width' => 1,
				'rounded_corners' => 25,
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('green_only_placeholders', 'wp_freshmail') => array
		(
			'form_container' => array(
				'width' => '350',
				'width2' => 'px',
				'background_color' => '#36c113',
				'border_color' => '#417d07',
				'border_width' => '0',
				'rounded_corners' => '5',
				'padding1' => '0',
				'padding2' => '20',
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => '18',
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#417d07',
				'text_size' => '11',
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => '0',
				'select_width' => '%',
				'position' => 'display:block;float:left;',
				'text_color' => '#ffffff',
				'text_size' => '12',
				'select_text_style' => 'font-style:normal;',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => '100',
				'select_field_width' => '%',
				'height' => '30',
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => '11',
				'border_color' => '#b7b7b7',
				'border_width' => '1',
			),
			'checkbox_agreement' => array(
				'display' => 'no',
				'checked' => 'no',
				'text_color' => '#417d07',
				'text_size' => '9',
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => '120',
				'select_width' => 'px',
				'height' => '40',
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => '11',
				'text_color' => '#ffffff',
				'background_color' => '#417d07',
				'border_color' => '#8c8c8c',
				'border_width' => '0',
				'rounded_corners' => '20',
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('black_only_placeholders', 'wp_freshmail') => array
		(
			'form_container' => array(
				'width' => '300',
				'width2' => 'px',
				'background_color' => '#000000',
				'border_color' => '#f14231',
				'border_width' => '0',
				'rounded_corners' => '0',
				'padding1' => '0',
				'padding2' => '40',
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => '20',
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#ffffff',
				'text_size' => '11',
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => '0',
				'select_width' => 'px',
				'position' => 'clear:left;display:block;',
				'text_color' => '#ffffff',
				'text_size' => '0',
				'select_text_style' => 'font-style:normal;',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => '100',
				'select_field_width' => '%',
				'height' => '30',
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => '12',
				'border_color' => '#b7b7b7',
				'border_width' => '1',
			),
			'checkbox_agreement' => array(
				'display' => 'yes',
				'checked' => 'no',
				'text_color' => '#c1c1c1',
				'text_size' => '9',
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => '130',
				'select_width' => 'px',
				'height' => '44',
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => '11',
				'text_color' => '#ffffff',
				'background_color' => '#000000',
				'border_color' => '#ffffff',
				'border_width' => '1',
				'rounded_corners' => '25',
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
		__('blue_only_placeholders', 'wp_freshmail') => array
		(
			'form_container' => array(
				'width' => '300',
				'width2' => 'px',
				'background_color' => '#1b3558',
				'border_color' => '#f14231',
				'border_width' => '0',
				'rounded_corners' => '0',
				'padding1' => '0',
				'padding2' => '40',
			),
			'text_header' => array(
				'display' => 'yes',
				'text_color' => '#ffffff',
				'text_size' => '20',
				'text_alignment' => 'center',
			),
			'sub_header' => array(
				'display' => 'no',
				'text_color' => '#ffffff',
				'text_size' => '11',
				'text_alignment' => 'center',
			),
			'label' => array(
				'width' => '0',
				'select_width' => '%',
				'position' => 'clear:left;display:block;',
				'text_color' => '#ffffff',
				'text_size' => '0',
				'select_text_style' => 'font-style:normal;',
				'display_placeholders' => 'yes',
			),
			'field' => array(
				'width' => '100',
				'select_field_width' => '%',
				'height' => '30',
				'select_field_height' => 'px',
				'text_color' => '#5e5e5e',
				'text_size' => '11',
				'border_color' => '#b7b7b7',
				'border_width' => '1',
			),
			'checkbox_agreement' => array(
				'display' => 'yes',
				'checked' => 'no',
				'text_color' => '#9aabb7',
				'text_size' => '9',
				'text_aligment' => 'center',
			),
			'button' => array(
				'width' => '120',
				'select_width' => 'px',
				'height' => '40',
				'select_height' => 'px',
				'select_aligment' => 'center',
				'text_size' => '11',
				'text_color' => '#ffffff',
				'background_color' => '#f14231',
				'border_color' => '#8c8c8c',
				'border_width' => '0',
				'rounded_corners' => '5',
			),
			'button_hovered' => array(
				'background_color' => '',
				'border_color' => '',
				'text_color' => '',
			),
			'error_success' => array(
				'error_text_color' => '',
				'success_text_color' => '',
			),
		),
	));

	update_option('freshmail_custom_theme', $default_theme);
	delete_option('fm_sign_up_checkboxes');
}