<?php
/*
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

add_action('admin_enqueue_scripts', 'freshmail_admin_enqueue_scripts');
function freshmail_admin_enqueue_scripts()
{
	wp_register_script('freshmail-script', WP_FRESHMAIL_URL.'/assets/js/scripts.js', array('jquery', 'wp-color-picker'));
	wp_enqueue_script('freshmail-script');

	wp_localize_script('freshmail-script', 'static_var', array(
		'plugin_url' => WP_FRESHMAIL_URL,
		'ajax' => admin_url('admin-ajax.php')
	));

	wp_enqueue_style('freshmail-style', WP_FRESHMAIL_URL.'/assets/css/style_admin.css');
	wp_enqueue_script('jquery-ui-accordion');
	wp_enqueue_style('wp-color-picker');
}

add_action('wp_enqueue_scripts', 'freshmail_enqueue_scripts');
function freshmail_enqueue_scripts()
{
	wp_enqueue_style('freshmail-style', WP_FRESHMAIL_URL.'/assets/css/style.css');
	wp_enqueue_style("wp-jquery-ui-dialog");

	$handle = 'freshmail-script';
	wp_register_script($handle, WP_FRESHMAIL_URL.'/assets/js/user.js', array('jquery', 'jquery-ui-dialog', 'jquery-ui-tooltip'));
	wp_enqueue_script($handle);

	$script_params = array(
		'plugin_url' => WP_FRESHMAIL_URL,
		'ajax' => admin_url('admin-ajax.php')
	);

	wp_localize_script($handle, 'static_var', $script_params);
}

function addEmailToDb($email, $ext_fields, $referer, $form_id, $freshmail_list_id)
{
	global $wpdb;
	global $rest;

	initFreshMailVariable();

	if (!is_object($rest)) {
		include_once(WP_FRESHMAIL_DIR.'/include/class.rest.php');
		$rest = new FmRestAPI();
		$rest->setApiKey(FM_API_KEY);
		$rest->setApiSecret(FM_API_SECRET);
	}

	if (!$wpdb->insert($wpdb->prefix.'fm_mails',
		array(
			'email' => $email,
			'ext_fields' => serialize($ext_fields),
			'form_id' => $form_id,
			'referer' => $referer
		),
		array('%s', '%s', '%s', '%s')
	)) {
		return false;
	}

	if (!$wpdb->insert_id) {
		return false;
	} else {
		$custom_fields = array();
		if (count($ext_fields) > 1) {
			foreach ($ext_fields as $key => $val) {
				if ($key != "email") {
					$custom_fields[$key] = $val;
				}
			}
		}

		try {
			$postdata = array('email' => $email, 'list' => $freshmail_list_id, 'custom_fields' => $custom_fields);
			$response = $rest->doRequest('subscriber/add', $postdata);
		} catch (Exception $e) {
			print_r($e);
		}

		return true;
	}
}

function count_themes()
{
	$themes = get_option('freshmail_custom_theme');

	return (empty($themes)) ? null : count(unserialize($themes));
}

function update_themes($appearance, $key = null)
{
	$custom_theme = get_option('freshmail_custom_theme');

	//delete_option('freshmail_custom_theme');

	if (empty($custom_theme)) {
		$custom_theme = array();
	} else {
		$custom_theme = unserialize($custom_theme);
	}

	if ($key != null) {
		$custom_theme[$key] = $appearance;
	} else {
		$custom_theme[] = $appearance;
	}

	update_option('freshmail_custom_theme', serialize($custom_theme));

	return $custom_theme;
}

function freshmail_notice()
{
	global $fm_notice;
	echo $fm_notice;
}