<?php
/**
 *
 *  _____ ____  _____ ____  _   _ __  __    _    ___ _       ____ ___  __  __
 * |  ___|  _ \| ____/ ___|| | | |  \/  |  / \  |_ _| |     / ___/ _ \|  \/  |
 * | |_  | |_) |  _| \___ \| |_| | |\/| | / _ \  | || |    | |  | | | | |\/| |
 * |  _| |  _ <| |___ ___) |  _  | |  | |/ ___ \ | || |___ | |__| |_| | |  | |
 * |_|   |_| \_\_____|____/|_| |_|_|  |_/_/   \_\___|_____(_)____\___/|_|  |_|
 *
 *
 * FreshMail is a browser-based software for sending and tracking
 * email marketing campaigns. FreshMail is absolutely free if you send
 * less than 2 000 e-mails up to 500 subscribers per month.
 *
 * Visit: http://freshmail.com/
 *
 */

// Localisation
load_plugin_textdomain('wp_freshmail', false, dirname(plugin_basename(__FILE__)).'/i18n/');

global $fm_settings;
global $fresh_connected;
global $rest;
global $fm_notice;

add_action('init', 'initFreshMailVariable', 5);
function initFreshMailVariable()
{
	if (!defined('FM_API_KEY')) {
		define ('FM_API_KEY', get_option('freshmail_api_key'));
	}
	if (!defined('FM_API_SECRET')) {
		define ('FM_API_SECRET', get_option('freshmail_api_secret_key'));
	}

	global $fm_settings, $fresh_connected;

	$fm_settings = array();
	$fm_settings['fm_sign_up_checkboxes'] = get_option('fm_sign_up_checkboxes', true);
	$fresh_connected = false;

	connectToFreshMail();
}

function connectToFreshMail($first = false)
{
	global $fresh_connected, $fresh_connected_error, $rest;

	if ($first === false) {
		$fresh_connected = get_option('freshmail_api_connected');
	} else {
		if (!is_object($rest)) {
			if (FM_API_SECRET != '') {
				require_once(WP_FRESHMAIL_DIR.'/include/class.rest.php');
				$rest = new FmRestAPI();
				$rest->setApiKey(FM_API_KEY);
				$rest->setApiSecret(FM_API_SECRET);
				try {
					$rest->doRequest('ping');
					$fresh_connected = true;
				} catch (Exception $e) {
					$fresh_connected_error = $e->getMessage();
				}
			}
		}
	}
}

$dh = opendir(WP_FRESHMAIL_DIR.'/include');
while (false !== ($filename = readdir($dh))) {
	if (substr($filename, -4) == ".php") {
		include_once(WP_FRESHMAIL_DIR.'/include/'.$filename);
	}
}